void bot_t::SV_ParseVoiceData (const bool isFinalData)
{
	// Gets voice data from a client and forwards it to anyone who can hear this client.

	if (/*cls.state != ca_active || */!GetChatterManager ()->Voice_IsRecording ())
		return;

	// Disable voice?
	if (sv_voiceenable->value == 0.0f)
		return;

	// Get whatever compressed data there is and and send it.
	char voiceData[2048u];
	const unsigned short voiceDataLength (GetChatterManager ()->Voice_GetCompressedData (voiceData, sizeof (voiceData), isFinalData));

	if (voiceDataLength == 0u)
		return;

	edict_t *const sourceClient (pEdict);	// this bot
	const unsigned char sourceClientIndex (static_cast <unsigned char> (ENTINDEX (sourceClient)));

	for (unsigned char destinationClientIndex (1u); destinationClientIndex <= gpGlobals->maxClients; ++destinationClientIndex)
	{
		edict_t *const destinationClient (INDEXENT (playerIndex));
		const bool isLocalClient (sourceClient == destinationClient);

		// Skip bot ourself!
		if (isLocalClient)
			continue;

		// Is this client even on the server?
		if (FNullEnt (destinationClient))
			continue;

		// Skip other bots....
		if (destinationClient->v.flags & FL_FAKECLIENT)
			continue;

		// Does the game code want 'sourceClientIndex' sending to this client?
		if (!(*g_engfuncs.pfnVoice_GetClientListening) (destinationClientIndex, sourceClientIndex)/* && !isLocalClient*/)
			continue;

		unsigned short sendVoiceDataLength (voiceDataLength);
/*
		// Is loopback enabled?
		if (isLocalClient && !destinationClient.m_bLoopback)
			sendVoiceDataLength = 0u;	// Still send something, just zero length (this is so the client can display something that shows knows the server knows it's talking).

		// Is there room to write this data in?
		if (destinationClient.datagram.cursize + sizeof (unsigned char) + 2u + sizeof (sourceClientIndex) + sizeof (sendVoiceDataLength) + sendVoiceDataLength/*voiceDataLength - I COMMENTED IT CUZ WE SENT 'sendVoiceDataLength' INSTEAD OF IT!!!*//* >= destinationClient.datagram.maxsize)
			continue;
*/
		(*g_engfuncs.pfnMessageBegin) (MSG_ONE_UNRELIABLE, SVC_VOICEDATA, NULL, destinationClient);	// begin message
			(*g_engfuncs.pfnWriteByte) (sourceClientIndex - 1u/* zero based */);
			(*g_engfuncs.pfnWriteShort) (sendVoiceDataLength);

			for (unsigned short index (0u); index < sendVoiceDataLength; ++index)
				(*g_engfuncs.pfnWriteByte) (static_cast <unsigned char> (voiceData[index]));

		(*g_engfuncs.pfnMessageEnd) ();	// end of message
	}
}

void BotThink (bot_t *pBot)
{
	// ...

	if (IsAlive (pBot))
	{
	if (pHostEdict->v.button & IN_USE)	// FOR EXAMPLE. Host client must push 'E' (use) button and hold it that the bot has started to speak....
	{
		if (!pBot->GetChatterManager ()->Voice_IsRecording ())
		{
			const char *pUncompressedFile (NULL);
			const char *pDecompressedFile (NULL);
			const char *pInputFile (NULL);

			if (CVAR_GET_FLOAT ("voice_recordtofile") != 0.0f)
			{
				// Set default filenames.
				pUncompressedFile = "voice_micdata.wav";
				pDecompressedFile = "voice_decompressed.wav";
			}

			// Wave file should be: Signed 16 bit PCM, 1 channel, 8000 Hz
			if (CVAR_GET_FLOAT ("voice_inputfromfile") != 0.0f)
				pInputFile = "voice_input.wav";	// Set default filename.
			else
			{
				const char *const inputFilename (CVAR_GET_STRING ("voice_inputfromfile"));

				if (inputFilename != NULL && inputFilename[0u] != '\0' && !isdigit (inputFilename[0u]))
					pInputFile = inputFilename;
			}

			pBot->GetChatterManager ()->Voice_RecordStart (pUncompressedFile, pDecompressedFile, pInputFile);
		}
		else
			pBot->SV_ParseVoiceData (false);
	}
	else if (pBot->GetChatterManager ()->Voice_IsRecording ())
	{
		pBot->SV_ParseVoiceData (true);	// Send the final data packet....

		pBot->GetChatterManager ()->Voice_RecordStop ();
	}
	}

	// ...
}